  /*
 *  Imker Stockwaage mit Upload mit 3g itead 
 
 www.Imker-Stockwaage.de
 Copyright Achim Pfaff
 
 Circuit:
 * Temperatur&Humidity sensor attached to digital in 2 or 4
 * GPRS Shield attached to digital 6,7 
 + Waage an Pin Analog 2,3
 
 */
 
 #include "DHT.h"
 #include "LowPower.h"
 #include <Wire.h>
 #include <Adafruit_MPL115A2.h>  // Drucksensor Adafruit
 #include <SoftwareSerial.h>
 #include "Barometer.h" // Drucksensor BMP085 / 180 
 #include <OneWire.h>  // für Brutraumsensor DS18S20

//Daten Imker-Stockwaage Webseite
#define Sendeart       0    // 0 Sendeart per GSM   1  Sendeart SMS (per SMS pro Zeiteinheit)   3 Sendeart beides simultan
#define Sendeart2       0   // 0 Schwarmalarmierung per Anruf auf die angegebene Telefonnummer oder 1 per SMS
#define Sendeart1       0    // 0 Sendeart per ITEAD UMTS Modem   1  Sendeart mittels Sim 900 Modem 
#define SLEEPMin  60  // Daten alle .... min. senden Bei SMS Versand (Sendeart 1 und 3 sollte es für eintäglich auf 1440 und für halbtäglich auf 720 min. ansonsten wird es teuer
#define Drucksensor 0  // 0 Standard Drucksensor Adafruit MPL115A2,  1 BMP 180/085 Sensor
#define Brutraumsensor 0  // 0 kein Sensor,  1 Brutraumsensor vorhanden (Wenn 1 muss auch ein Sensor angeschlossen sein ansonsten bleibt die Sftware stehen
#define Regensensor 0 //  0 kein Sensor  1 Sensor angeschlossen  !!!! Pin für DHT 22 ist normal D2 muss auf D4 geändert werden.
int Regenfaktor = 1; // liter pro m^2  Wasser pro impuls vom Regenzähler (2 bei 2 Impulsen pro mm Regen...)
#define DHTPIN 2            // Temperature&Humidity sensor port vorher 2 XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXx
int waagenid = 1234;         // hier eine einzigartige ID für die Waage vergeben, diese ist nur für diese Waage gültig sonst gibts Datenbankprobleme
#define BaudrateGPRS  38400       // GPRS baud rate max. 38400 oder 9600 (bei manchen Modems gibt es Probleme mit 38400)  19200 bei SIM900 Modem

// Daten für MYSQL Datenbank 
char server[ ]=         "server.de";   // webseite ohne www und ohne Unterverzeichnis z.b. beescale.pf-control.de
char port[ ]=           "80";   // Bei MYSQL 80
char url[]  = "/data2mysql.php"; // Pfad zur PHP-Datei (data2mysql.php) eingeben ohne die  wenn Unterverzeichnisse eingesetzt werden bitte /unterverzeichnis/data2mysql.php
char key[]     = "Password"; // Passwort PHP Datei

// Daten für Netzbetreiber der Handykarte  
#define APN         "pinternet.interkom.de" //  APN des Netzwerkdienstes. (hier O2)
#define Username    ""      // Username  APN 
#define Passwort    ""      // Passwort APN
#define PIN         ""      // Pin der Sim Karte
char phone_number[]="+49XXXXXX";  //anzurufende Nummer bei Schwarmalarm
char SMS_number[]="+49XXXXXX";    // SMS Nummer für Akkualarm und SMS Übertragung
char SMS_Kurzmitteilungsnummer[]="+49XXXXXX"; //Spezifische SMS Kurzmitteilungsnummer (Kurzmitteilungszentrale) des Handykartenanbieters

float Akkualarmwert = 11.6;  //  Alarm bei Unterschreitung dieses Wertes.Bleiakku min. 10.8, besser 11.6
float diffTemp  = 0;  // DIfferenztemperatur des Drucksensors, bei Adafruit 2.6(°C), beim BMP180 0(°C)

// Werte für analogen Gewichssensor für kalibration Sensor 1  (Analog 3)  Volk 1
#define kal1_Wert_1_1     1000    //Lesewert1 für
#define kal1_Gewicht_1_1  1700   //....kg
#define kal1_Wert_1_2     5000  //Lesewert2 für
#define kal1_Gewicht_1_2  7280 //kg

// Werte für analogen Gewichssensor für kalibration Sensor 2  (Analog 2)  Volk 2
#define kal2_Wert_1_1     1000    //Lesewert1 für
#define kal2_Gewicht_1_1  1700   //....kg
#define kal2_Wert_1_2     5000  //Lesewert2 für
#define kal2_Gewicht_1_2  7280 //kg


 //Daten Imker-Stockwaage Webseite Ende

#define Schwarm 5  // alle ... min. Schwarmabfrage während schlafen, erste nach 1 min. (wenn Schlafzeit bei 1 Min. liegt.
#define SleepPIN13 13    // Sleep Pin für DMS Verstärker
#define SleepPIN12 12 // neuer Gewichtssensor
#define SleepPINGSM 3    // neuer sleep Modul GSM über Mofset
#define DHTTYPE DHT22   // DHT 22  (AM2302)
#if Sendeart1 == 0         // Pin einschalten für 3G shield
  #define onModulePin  8
 #endif
#if Sendeart1 == 1         // Pin einschalten für SIM 900
  #define onModulePin  9
 #endif

//#define onModulePin 8    // Pin 3G Modem einschalten
#define ResetModulePin 9 // Pin 3G Modem Reset
#define PINinterrupt 0 // Pin 2 für Interrupt 0  XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX 


DHT dht(DHTPIN, DHTTYPE);    // DHT Sensor
Adafruit_MPL115A2 mpl115a2; // Drucksensor MPL115A2
Barometer myBarometer;     // Drucksensor BMP180/085

float celsius;   //Brutraumtemp
float humidity,temperature;   // Werte Luftfeuchtigkeit und Temperatursensor
float analogValuekg3 = analogRead(3);  // analoger Wert an Pin3 für Wägezelle
float analogValuekg2 = analogRead(2);  // analoger Wert an Pin2 für Wägezelle
float analogAkku = analogRead(1);  // analoger Wert an Pin... für Spannungsmessung vom Akku
float gewicht2 = 0;
float gewicht3 = 0;
float Akku = 0;
int SLEEP = (SLEEPMin*7); // Umrechnung Schlafzeit von min. in interne Zahl
int SAb = (Schwarm*7);  // Umrechnung Schwarmabfrage von min. in interne Zahl
int maxdiff = 10; // 5 entspricht einem kg Maximale Gewichtsdifferenz für Schwarmalarm
int letztesGewicht3;  // letztes Gewicht für Schwarmabgang
int letztesGewicht2;  // letztes Gewicht für Schwarmabgang
int Akkusmsgesendet = 0;  // Akku leer SMS gesendet =1 bei 0 noch nicht gesendet
int Volk = 0; // Angabe welches Volk geschwärmt ist
volatile int Regenzaehler = 0; // Zähler Regensensor  XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

float pressureKPA1 = 0, temperatureC1 = 0; // Werte für P und T Sensor ausgelesen
float pressureKPA = 0, temperatureC = 0; // Werte für P und T Sensor umgerechnet
int SMSsafe =0; // Sicherheit wenn SMS für Akku nicht gesendet wurde, dass maximal das SMS versenden mal versucht wird.
float CSQ_Wert =0; // CSQ Wert

int8_t answer;


int x = 0;
int creg_info = 0;

#if Sendeart1 == 0         // Softwareserial einschalten für 3G shield
  SoftwareSerial GPRS(6,7);
 #endif
 #if Sendeart1 == 1         // Softwareserial einschalten für SIM900
  SoftwareSerial GPRS(7, 8);
 #endif


//*********************************************************************************************************************************************************************
void setup(){
  
  Serial.begin(115200);




  
  delay(1000);
  int z = 0;
  while(z < 10){
   // mach etwas wiederholendes 10 mal warten, um Programmierung aufzuspielen, nicht unbedingt nötig
   z++;
   Serial.println(z);
   delay(1000);
  }
   
  pinMode(SleepPINGSM, OUTPUT);  // Sleppin oGSM
  digitalWrite(SleepPINGSM, HIGH);  // Schalte GSM ein
  delay(100);
  GPRS.begin(BaudrateGPRS);                
  delay(1000);
  pinMode(ResetModulePin, OUTPUT);
  pinMode(SleepPIN13, OUTPUT);  // Sleppin output für DMS Zelle
  digitalWrite(SleepPIN13, HIGH);  // Schalte DMS ein
  pinMode(SleepPIN12, OUTPUT);  // Sleppin Waage 2 (gleichzeitig Stromversorgung)
  digitalWrite(SleepPIN12, HIGH);  // Schalte Waage 2 ein
    
  delay(2000);  
  
 if(Drucksensor ==0) {mpl115a2.begin();} //Drucksensor Start  
 if(Drucksensor ==1) {myBarometer.init();} //Drucksensor BMP 180/085 Start
 dht.begin();      // DHT Sensor Start
 if(Regensensor ==1) {attachInterrupt(PINinterrupt, Regenmessung, FALLING);
 digitalWrite(2, HIGH);} ////Drucksensor Start  
}



//*********************************************************************************************************************************************************************
void loop()
{ leseDaten(); // lese Daten aus Sensoren
  startMODUL();
  delay(5000); // für Waldeinsatz und schlechten Empfang 0 standard
  if (Sendeart == 1 or Sendeart == 3){                      //SMS senden
  DatenSMSsenden();
  //SLEEP = 10080; //Setzt Schlafzeit bei SMS Versand auf ca. alle 24 Stunden.
  }  
  if (Sendeart == 0 or Sendeart == 3){                      //GSM senden
  startGSM();
  http_put(); 
  } 
  Serial.println("01");
  delay(4000); // neu damit daten sicher gesendet werden.
  if (Akku/10 <= (Akkualarmwert-0.1)){SLEEP = 10080;} //Setzt Schlafzeit bei schwachem Akku auf ca. alle 24 Stunden.
  if (Akku/10 <= (Akkualarmwert-0.4)){SLEEP = 70560;} //Setzt Schlafzeit bei schwachem Akku auf ca. alle 7 TAGE.
  if (Akku/10 >= (Akkualarmwert+0.5)){SLEEP = SLEEPMin*7; Akkusmsgesendet = 0;} //Setzt Schlafzeit bei vollem Akku wieder auf Normale Zeit.
  sleep();  // führt Sleep aus immer 8s Mal Parameter SLEEP
}

//*********************************************************************************************************************************************************************
int8_t sendATcommand(char* ATcommand, char* expected_answer1,
        unsigned int timeout)
{

    uint8_t x=0,  answer=0;
    char response[100];
    unsigned long previous;

    memset(response, '\0', 100);    // Initialize the string
    
    delay(1000);
    
    while( GPRS.available() > 0) GPRS.read();    // Clean the input buffer
    
    GPRS.println(ATcommand);    // Send the AT command 
    delay(3000);
    x = 0;
    previous = millis();

    // this loop waits for the answer
    do{

        if(GPRS.available() != 0){    
            response[x] = GPRS.read();
             
            x++;
            
            // check if the desired answer is in the response of the module
            if (strstr(response, expected_answer1) != NULL)    
            { 
              answer = 1;
            }
        }
        // Waits for the answer with time out
    }while((answer == 0) && ((millis() - previous) < timeout));    
    
    Serial.println(response);
    return answer;
}


//**ERROR 10 *******************************************************************************************************************************************************************
void http_put() { 
  Serial.println("11"); 
  char data[256];
  Serial.println("12");
  int data_size;
  char aux_string[50];
  Serial.println("13");

// waits for an answer from the module
      
   if (Sendeart1 == 0) {   
        int i = 0;
        do {
            sprintf(aux_string, "AT+CHTTPACT=\"%s\",%s", server, port);
            answer = sendATcommand(aux_string, "+CHTTPACT: REQUEST", 60000);  
         i++;  
        
        } while(i<3 && answer == 0);    // 3 Versuche
  Serial.println(aux_string);
  GPRS.flush();
  Serial.println(answer);
   }

if (Sendeart1 == 1) {
 if ( sendATcommand("AT+HTTPINIT", "OK", 10000) == 1 )
     {
       
        if ( sendATcommand("AT+HTTPPARA=\"CID\",1", "OK", 5000) == 1 )
        {Serial.println("131");
        answer = 1;}}}


  // #####################################################################################################################################
   Serial.println("14");
  
 if (answer==1) {   // Wenn error keine Daten senden
  
  char Data[256]; 
  char SendCmd[25];
  int i;
  i=0; memset(Data,'\0',256);
  int leer=0;
  static char dtostrfbuffer[15];
  
  // Request Syntax for TCP Socket Connection Type  
 // Daten in Array speichern
if (Sendeart1 == 1) { 
i += sprintf (Data+i, "AT+HTTPPARA=\"URL\",\"http://www.");
i += sprintf (Data+i, server);
i += sprintf (Data+i, url);
i += sprintf(Data+i, "?key=");
i += sprintf(Data+i, key);
}
 
  i += sprintf(Data+i, "%s", "");
  if (Sendeart1 == 0) {
  i += sprintf(Data+i, "?ID=");  
  }
  if (Sendeart1 == 1) {
    i += sprintf(Data+i, "&ID=");
  }
  dtostrf(waagenid,4, 0,  dtostrfbuffer);
  i += sprintf(Data+i, "%s", dtostrfbuffer);

  
  i += sprintf(Data+i, "&A0=");
  dtostrf(gewicht2/10,1, 2, dtostrfbuffer);
  i += sprintf(Data+i, "%s", dtostrfbuffer);
  
  i += sprintf(Data+i, "&A1=");
  dtostrf(gewicht3/10,1, 2, dtostrfbuffer);
  i += sprintf(Data+i, "%s", dtostrfbuffer);
  
  i += sprintf(Data+i, "&A2=");
  dtostrf(pressureKPA+36,1, 1, dtostrfbuffer); //38
  i += sprintf(Data+i, "%s", dtostrfbuffer);
  
  i += sprintf(Data+i, "&A3=");
  dtostrf(temperatureC+diffTemp,1, 1, dtostrfbuffer);
  i += sprintf(Data+i, "%s", dtostrfbuffer);
  
  i += sprintf(Data+i, "&A4=");
  dtostrf(temperature,1, 1, dtostrfbuffer);
  i += sprintf(Data+i, "%s", dtostrfbuffer);
  
  i += sprintf(Data+i, "&A5=");
  dtostrf(humidity,1, 1, dtostrfbuffer);
  i += sprintf(Data+i, "%s", dtostrfbuffer);
  
  i += sprintf(Data+i, "&A6=");
  dtostrf(Akku/10,1, 2, dtostrfbuffer);
  i += sprintf(Data+i, "%s", dtostrfbuffer);
  
  i += sprintf(Data+i, "&A7=");
  dtostrf(CSQ_Wert,1, 1, dtostrfbuffer);
  i += sprintf(Data+i, "%s", dtostrfbuffer); 
  
  i += sprintf(Data+i, "&A8=");
  dtostrf(celsius,1, 1, dtostrfbuffer);
  i += sprintf(Data+i, "%s", dtostrfbuffer);
  
  i += sprintf(Data+i, "&A9=");
  dtostrf(Regenzaehler/Regenfaktor,1, 0, dtostrfbuffer);
  i += sprintf(Data+i, "%s", dtostrfbuffer);
  Regenzaehler = 0; // Nach senden der Daten den Regenzähler zurücksetzen.
  
  i += sprintf(Data+i, "&A10=");
  dtostrf(leer,1, 0, dtostrfbuffer);
  i += sprintf(Data+i, "%s", dtostrfbuffer);
  
  i += sprintf(Data+i, "&A11=");
  dtostrf(leer,1, 0, dtostrfbuffer);
  i += sprintf(Data+i, "%s", dtostrfbuffer);
  
  i += sprintf(Data+i, "&A12=");
  dtostrf(leer,1, 0, dtostrfbuffer);
  i += sprintf(Data+i, "%s", dtostrfbuffer);
    
 
 
  Serial.println(Data);
  
  
 
 
 if (Sendeart1 == 0) {
  GPRS.print("GET ");
  GPRS.print(url);
  GPRS.print(Data);
  GPRS.print("&key=" + String(key));
  GPRS.println(" HTTP/1.1");
  GPRS.print("Host: ");
  GPRS.println(server);
  GPRS.println();
  Serial.println("15");
  Serial.println(":");
  Serial.println(url);
 
//**************  fehler auslesen wenn einer kommt.
#define AT_CHTTPACT_DATA_RESPONSE ("+CHTTPACT: DATA,")
 char aux_str [50];
 aux_str[0] = 0x1A; 
 aux_str[1] = 0x00; 
 answer = sendATcommand(aux_str, AT_CHTTPACT_DATA_RESPONSE, 100000);
 if(answer == 1) 
 { 
 Serial.println(AT_CHTTPACT_DATA_RESPONSE); 
       
 while(GPRS.available() > 0) { 
 Serial.print((char)GPRS.read()); 
  } }
// Fehler auslesen Ende
 
 
 /* 
  GPRS.write(0x1A);       
  GPRS.write(0x0D);
  GPRS.write(0x0A);*/
 Serial.println("16");
}

if (Sendeart1 == 1) {
GPRS.print(Data);
            if ( sendATcommand("\"", "OK", 15000) ) {
                // Starts GET action
                if ( sendATcommand("AT+HTTPACTION=0", "+HTTPACTION:0,200", 30000) == 1 ) {
                  if (sendATcommand("AT+HTTPREAD","RRR",2000) == 1)
                        {
                          Serial.println(F("MAJ OK"));
                          
                        } 
                  }
                      #if defined(DEVMODE)
                else
                { Serial.println(F("Error getting url")); }
                #endif
            }
            #if defined(DEVMODE)
            else
            {
                Serial.println(F("Error setting the url"));
            } 
            #endif
}}

Serial.println("17");
}


//*Error 20 ********************************************************************************************************************************************************************
void startMODUL(){
  Serial.println("21");
  digitalWrite(SleepPINGSM, HIGH);  // Schalte GSM ein
  delay(200);
  
  uint8_t answer=0;
  answer = sendATcommand("AT", "OK", 2000);
    if (answer == 0){
  pinMode(onModulePin, OUTPUT);
  if (Sendeart1 == 1) {digitalWrite(onModulePin,LOW);
    delay(1000);}
  digitalWrite(onModulePin,HIGH);
  if (Sendeart1 == 0) {delay(180);}
  if (Sendeart1 == 1) {delay(500);}
  digitalWrite(onModulePin,LOW);
  delay(6000);
// waits for an answer from the module
  int i = 0;
do {
            answer = sendATcommand("AT", "OK", 2000) ;  
         i++;  
        Serial.println(i);
        Serial.println(answer);
        } while(i<5 && answer == 0);    // 5 Versuche



 Serial.println(answer);
  Serial.println("22");



    }
}
  
//*Error 300 ********************************************************************************************************************************************************************
void startGSM(){
 
   if (Sendeart1 == 0) { readCSQ();   }// CSQ (Signalqualität) auslesen geht erst wenn Modem an ist ITEAD.
 
char aux_string[50];
byte i = 10;
   Serial.println("31");  
   delay(1000); 
    
   if (Sendeart == 0 ){ cpin(); }  // PIN Simkarte setzen   bei Sendeart 3 wurde der Pin bereits durch das SMS senden gesetzt.
    
    creg();
  if (Sendeart1 == 1) { readCSQ();   }// CSQ (Signalqualität) auslesen geht erst wenn Modem an ist Sim900.
  
  if (Sendeart1 == 0) {
   sprintf(aux_string, "AT+CGSOCKCONT=1,\"IP\",\"%s\"", APN, ";" );
   answer = sendATcommand(aux_string, "OK", 2000);
   Serial.println(aux_string);
   Serial.println(answer);
   sprintf(aux_string, "AT+CSOCKAUTH=1,1,\"%s\",\"%s\"", Username ,Passwort );
   answer = sendATcommand(aux_string, "OK", 2000);
   Serial.println(aux_string);
   Serial.println(answer); //Versuch mit Variablen 
  } 
  if (Sendeart1 == 1) {
GPRS.println(("AT+SAPBR=0,1"));
      // sets APN , user name and password
      sendATcommand("AT+SAPBR=3,1,\"CONTYPE\",\"GPRS\"", "OK", 2000);  // SAPBR=3,1  , 3=SET BEARER PARAMETERS  1 =  
          
      snprintf(aux_string, sizeof(aux_string), "AT+SAPBR=3,1,\"APN\",\"%s\"", APN);
      sendATcommand(aux_string, "OK", 2000);
      
      snprintf(aux_string, sizeof(aux_string), "AT+SAPBR=3,1,\"USER\",\"%s\"", Username);
      sendATcommand(aux_string, "OK", 2000);
      
      snprintf(aux_string, sizeof(aux_string), "AT+SAPBR=3,1,\"PWD\",\"%s\"", Passwort);
      sendATcommand(aux_string, "OK", 2000);

      while (  i != 0 && (sendATcommand("AT+SAPBR=1,1", "OK", 2000) == 0) )  // 1,1 = open Bearer 
      {
          --i;
          delay(2000);
          GPRS.println(F("AT+SAPBR=0,1")); // 
      } 
  }
  
  
    delay(5000);
   Serial.println("32"); 
}



//*Error 400 daten ********************************************************************************************************************************************************************
void leseDaten(){     // liest Daten von Sensoren aus
  Serial.println("41");
  humidity = 0;    // Mittelwert bilden
  celsius = 0;
  temperature = 0;
  pressureKPA = 0;
  temperatureC = 0;
  

  
  if(Brutraumsensor == 1){ getTemperatureSensors(10);    } // Brutraumtemperatur nur bei angeschlossenem Sensor auslesesen
  
  for(byte i = 0; i < 5; i++)
  {
  humidity += dht.readHumidity();
  temperature += dht.readTemperature();
  if(Drucksensor == 0){mpl115a2.getPT(&pressureKPA1,&temperatureC1); pressureKPA1=pressureKPA1*10;} // Drucksensor P und T auslesen Adafruit
  if(Drucksensor == 1){temperatureC1 = myBarometer.bmp085GetTemperature(myBarometer.bmp085ReadUT()); pressureKPA1 = (myBarometer.bmp085GetPressure(myBarometer.bmp085ReadUP())); pressureKPA1 /= 100;} // Drucksensor P und T auslesen BMP180/085
  pressureKPA += pressureKPA1;
  temperatureC += temperatureC1;
  delay(100);
  }
  humidity /= 5;
  temperature /= 5;
  pressureKPA /= 5;
  temperatureC /= 5; // Mittelwert bilden ende

Serial.println("Temperatur");
  Serial.print(celsius);
  
  pressureKPA=pressureKPA*1,1;      
  temperatureC=temperatureC*1,1;

if (isnan(humidity) || isnan(temperature)){   // Wenn NAN als Antwort durch einen nicht angeschlossenen DHT Sensor kommt, werden die Werte auf -777 gesetzt.
     humidity=-777;
     temperature=-777; }
  
  analogpin3(); // Waage an Analog 3 auslesen
  analogpin2(); // Waage an Analog 2 auslesen
  analogAkku1(); // Akku an Analog 1 auslesen
  }
  
  // Modul um kg am Pin0 analog auszulesen und in das Gewicht umzurechnen
  
//*********************************************************************************************************************************************************************  
void analogpin3() // Waage 1 auf Platine
{ Serial.println("42");
  
  analogValuekg3 = 0;
  for(byte i = 0; i < 10; i++) // Schleife 10 Messwerte Mittelwert bilden
  {
  analogValuekg3 += analogRead(3);
  // Serial.println(analogValuekg3/(i+1));
  //delay(100);
  }
  Serial.println("44");
  // lese Wert vom Analogpin in Variable
  int wert = analogValuekg3; // nur für Anzeige
  gewicht2=map(analogValuekg3,kal1_Wert_1_1,kal1_Wert_1_2,kal1_Gewicht_1_1,kal1_Gewicht_1_2); // umrechnen 450,4600,1400,9280
  gewicht2 /= 10; // Mittelwert bilden ende durch 100  da 10 Werte und 10fache Angabe
  // gebe das Ergebnis mit einer Nachkommastelle aus:
  letztesGewicht3 = analogValuekg3/10; // Wert für Schwarmabfrage setzen
  }



//*********************************************************************************************************************************************************************
void analogpin2()  // Waage 2 auf Platine
{ Serial.println("45");
  
  analogValuekg2 = 0;
  for(byte i = 0; i < 10; i++) // Schleife 10 Messwerte Mittelwert bilden
  {
  analogValuekg2 += analogRead(2);
 // Serial.println(analogValuekg2/(i+1));
 // delay(100);
  }
  Serial.println("47");
  int wert = analogValuekg2; // nur für Anzeige
  gewicht3=map(analogValuekg2,kal2_Wert_1_1,kal2_Wert_1_2,kal2_Gewicht_1_1,kal2_Gewicht_1_2); // umrechnen 940,4970,1400,9280
  gewicht3 /= 10; // Mittelwert bilden ende durch 100  da 10 Werte und 10fache Angabe
  // gebe das Ergebnis mit einer Nachkommastelle aus:
  letztesGewicht2 = analogValuekg2/10; // Wert für Schwarmabfrage setzen
}
//**Error 700*******************************************************************************************************************************************************************
void analogAkku1() 
{ Serial.println("71"); 
  analogAkku = 0;
  for(byte i = 0; i < 4; i++) // Schleife erste 4 Messwerte lesen, diese sind nicht stabil (geprüft ist wichtig eventuell 20 Werte für besseren Mittelwert nehmen)
  {
  analogAkku += analogRead(1);
  Serial.println(analogAkku/(i+1));
  delay(100);
  }
  Serial.println("72");
  // lese Wert vom Analogpin in Variable
   analogAkku = 0;
  for(byte i = 0; i < 10; i++) // Schleife 5 Messwerte Mittelwert bilden
  {
  analogAkku += analogRead(1);
  //Serial.println(analogAkku/(i+1));
  //delay(100);
  }
  Serial.println("73");
  Akku=map(analogAkku,7730,8150,1198,1265); // umrechnen
  // gebe das Ergebnis mit einer Nachkommastelle aus:
  Akku /= 10; // Mittelwert bilden ende durch 100  da 10 Werte und 10fache Angabe
 
}
//*Error 800********************************************************************************************************************************************************************


void readCSQ(){   // Dankke an Günter, der diese Routiene verbessert hat.
  Serial.println("81");
  String msg="";
  char a;
  int i;
  int j;
  String Z1;
  String Z2;
  
  Serial.println("81a");   
  GPRS.println("AT+CSQ"); //returned z.B. +CSQ 29,0  = RSSI,BER
  delay(100);
  
   while(GPRS.available()!=0){
    a=GPRS.read();
    msg.concat(a);
   delay(1);
   }
  if (msg.indexOf("+CSQ") >=0){
    i = msg.indexOf(":");      // Pos. ":"
    j = msg.indexOf(",");      // Pos ","
    Z1 = msg.substring(i+2, j); // RSSI, z.B. 19
    Z2 = msg.substring(j+1,j+2); // BER, z.B. 0
  
    msg=Z1+"."+Z2;
    CSQ_Wert = msg.toFloat();

    Serial.println(CSQ_Wert);
  }else{
    CSQ_Wert=-1;
    Serial.println("Error");
  }
}

//*********************************************************************************************************************************************************************

void Regenmessung() {
Regenzaehler++;
} // keine weiteren Operationen einbauen, es kann zu Komplikationen kommen.auch kein serial.print


//*********************************************************************************************************************************************************************

void getTemperatureSensors(int pin) {  // http://www.laub-home.de/wiki/Sensorino_-_Auslesen_verschiedener_Sensoren_mit_Arduino#DS18S20_1-Wire_.5BDIY.5D
  byte type_s;
  OneWire ds(pin);  
  byte addr[8]; 
  byte present = 0; 
  byte data[12];
  
 
  while(ds.search(addr)) {
    if (OneWire::crc8(addr, 7) != addr[7]) {
      Serial.println("CRC not valid");
      return;
    } else {
      switch (addr[0]) {
        case 0x10: // DS18S20 or old DS1820
          type_s = 1;
        break;
        case 0x28: // DS18B20
          type_s = 0;
        break;
        case 0x22: // DS1822
          type_s = 0;
        break;
        default: //Device is not a DS18x20 family device.
          type_s = -1; 
        return;
      }
      // conversion
      ds.reset();
      ds.select(addr);
      ds.write(0x44,1);   // start conversion
      delay(1000);      // conversion wait
      present = ds.reset();
      ds.select(addr);
      ds.write(0xBE);     // read sensor scratchpad
      for (int i = 0; i < 9; i++) {
        data[i] = ds.read();
      }
      // convert data to temperature
      int raw = (data[1] << 8) | data[0];
      if (type_s) {
        raw = raw << 3;
        if (data[7] == 0x10) {
          raw = (raw & 0xFFF0) + 12 - data[6];
        }
      } else {
        unsigned char t_mask[4] = {0x7, 0x3, 0x1, 0x0};
        byte cfg = (data[4] & 0x60) >> 5;
        raw &= ~t_mask[cfg];
      }
      
      celsius = (float)raw / 16.0;
     
    }
  }
  ds.reset_search();  
}


//**Error 81 + *******************************************************************************************************************************************************************
void sleep  () // Schlaafmodus + Gewichtsabfrage jede Minute wegen Schwarmabgang
{
  int SMS = 0;  // keine SMS senden
  int SMSAkku = 0;  // keine SMS senden
  delay(10);
  Serial.println("82");
  delay(1000);
  if (Sendeart1 == 0) {
    GPRS.println("AT+CPOF"); // 3G Modul ausschalten
  }
  if (Sendeart1 == 1) {
   sendATcommand("AT+CPOWD=1","NORMAL POWER DOWN", 5000);
  }
  delay(1000);
  digitalWrite(SleepPINGSM, LOW);  // Schalte GSM aus über Mofset, damit kein Strom gebraucht wird.  
  digitalWrite(SleepPIN13, LOW);  // Schalte DMS Waage 1 aus
  digitalWrite(SleepPIN12, LOW);  // Schalte Waage2 aus
  delay(100);
  for (int i=0; i <= SLEEP; i++){
    
    if (Regensensor == 0){ LowPower.powerDown(SLEEP_8S, ADC_OFF,   BOD_OFF);} // Arduino für 8 Sekunden schlafen lassen.
    if (Regensensor == 1){ for ( int j=0;  j<= 32; j++) {
      LowPower.powerDown(SLEEP_250MS, ADC_OFF,   BOD_OFF);}} // Arduino für 8 Sekunden schlafen lassen inden 32 mal 250 ms geschlafen wird.
   Serial.print("schlafen");
   
   Serial.println(i);
  // Serial.println("Regenzähler");
  // Serial.println(Regenzaehler);  // nur zum testen muss definitiv gelöcht werden um die Performance zu erhöhen.******************************************************
    delay(10);
    
    // ab hier abfrage ob Schwarm abgegangen ist
    if ((i == 7) || (i == SAb*1) || (i == SAb*2) || (i == SAb*3) || (i == SAb*4) || (i == SAb*5) || (i == SAb*6) || (i == SAb*7) || (i == SAb*8) || (i == SAb*9) || (i == SAb*10) || (i == SAb*11) || (i == SAb*12))   // alle ... minuten Gewicht abfragen, am Anfang nach einer Minute
    //if((i % SAb == 0) || (i == 7)) //  wenn i das vielfache von SAb ist dann Schwarmabfrage oder auch nach 1 min. nach Start (i =7) (% ist Modulo Operator)
    {
      digitalWrite(SleepPIN13, HIGH);  // Schalte DMS ein für kurze Abfrage
      digitalWrite(SleepPIN12, HIGH);  // Schalte DMS ein für kurze Abfrage
      delay(100); 
      analogValuekg3 = (analogRead(3)+analogRead(3)+analogRead(3)+analogRead(3)+analogRead(3)+analogRead(3)+analogRead(3)+analogRead(3)+analogRead(3)+analogRead(3))/10;  //Schwarmabgang ?
      Serial.println(letztesGewicht3);
      Serial.print("waage 1");
   Serial.println(analogValuekg3);
      analogValuekg2 = (analogRead(2)+analogRead(2)+analogRead(2)+analogRead(2)+analogRead(2)+analogRead(2)+analogRead(2)+analogRead(2)+analogRead(2)+analogRead(2))/10;  //Schwarmabgang ?
  Serial.println(letztesGewicht2);
   Serial.print("waage 2");
   Serial.println(analogValuekg2);  
      digitalWrite(SleepPIN13, LOW);  // Schalte DMS aus
      digitalWrite(SleepPIN12, LOW);  // Schalte Waage2 aus
      if (((letztesGewicht3-analogValuekg3) >= (maxdiff)) || ((letztesGewicht2-analogValuekg2) >= (maxdiff)))
      {
        if ((letztesGewicht3-analogValuekg3) >= (maxdiff)) {Volk = 1;}
        if ((letztesGewicht2-analogValuekg2) >= (maxdiff)) {Volk = 2;}
        i = (SLEEP+1); // Bei Schwarmabgang Schlafen beenden
        SMS = 1;  // Bei Schwarmabgang SMS senden
      }
      //Serial.println(letztesGewicht2-analogValuekg2);
      //Serial.println(analogValuekg2);
      letztesGewicht3 = analogValuekg3;
      letztesGewicht2 = analogValuekg2;
      if ((Akku/10) < Akkualarmwert && Akkusmsgesendet == 0 &&  SMSsafe < 3) { 
      i = (SLEEP+1); // Bei Akkustand low Schlafen beenden, nur wenn es das erste mal vorgekommen ist.
      SMSAkku = 1;
    }
     
      delay(100);
    }// Ende Schwarmabfrage
    }
   
    digitalWrite(SleepPIN13, HIGH);  // Schalte DMS ein
    digitalWrite(SleepPIN12, HIGH);  // Schalte DMS ein
    delay(100);

    if (SMS == 1) // SMS wenn Schwarmabgang
    {
      Anruf();
    }
    
    if (SMSAkku == 1) // SMS wenn Schwarmabgang
    {
      SMSsendenAkku();
    }
    
    
} // Ende Sleep


//*Error 90********************************************************************************************************************************************************************
void DatenSMSsenden() {
   char aux_string[30];
  Serial.println("91");
    delay(1000);
    
     cpin();   // PIN Simkarte setzen
    
    creg();    // CREG durchführen
    if (creg_info == 0){ 
  
    sendATcommand("AT+CMGF=1", "OK", 1000);    // sets the SMS mode to text
    sprintf(aux_string,"AT+CSCA=\"%s\"", SMS_Kurzmitteilungsnummer); 
    answer = sendATcommand(aux_string, "OK", 2000);    // Kurzmitteilungsnummer senden
    
    sprintf(aux_string,"AT+CMGS=\"%s\"", SMS_number);
    answer = sendATcommand(aux_string, ">", 2000);    // send the SMS number
    delay(200);
    if (answer == 1)
    {
  
  GPRS.print("Gewicht_Volk_1, ");
  GPRS.print(gewicht2/10,1);
  GPRS.println(" kg");
  GPRS.print("Gewicht_Volk_2, ");
  GPRS.print(gewicht3/10,1);
  GPRS.println(" kg");
  GPRS.print("Luftdruck, ");
  GPRS.print(pressureKPA+36,0);
  GPRS.println(" mbar");
  GPRS.print("Temperatur, ");
  GPRS.print(temperature,1);
  GPRS.println(" Grad C");

        
        GPRS.write(0x1A);
        delay(100);
        answer = sendATcommand("", "OK", 20000);
        if (answer == 1)
        {
            Serial.print("92");    
        }
        else
        {
            Serial.print("93");
        }
    }
    } 
    else
    {   Serial.println("94"); 
        Serial.println(answer, DEC);
    }
}


//**Error 500 *******************************************************************************************************************************************************************
void Anruf()  // Anruf wegen Schwarm oder SMS senden

  
{ Serial.println("51"); 
  char aux_string[30];
    startMODUL();
  int i = 0; 
  
  if(Sendeart2 == 0) { // Anruf
  Serial.println("52"); 
  delay(10000);
  cpin();   // PIN Simkarte setzen
  sprintf(aux_string, "ATD%s;", phone_number, ";" ); //Nummer wählen
  sendATcommand(aux_string, "OK", 10000);
  delay(30000);
  GPRS.print("AT+CVHU=0");
  GPRS.print("ATH");
  GPRS.println("AT+CPOF"); // 3G Modul ausschalten
  delay(1000);
  digitalWrite(SleepPINGSM, LOW);  // Schalte GSM aus
  delay(1000);
}

if(Sendeart2 == 1) { // SMS
  delay(5000); // für Waldeinsatz und schlechten Empfang 0 standard
  Serial.println("53");
    delay(1000);
    cpin();   // PIN Simkarte setzen
    creg();    // CREG durchführen
    if (creg_info == 0){ 
    
     
     
    sendATcommand("AT+CMGF=1", "OK", 1000);    // sets the SMS mode to text
    sprintf(aux_string,"AT+CSCA=\"%s\"", SMS_Kurzmitteilungsnummer); 
    answer = sendATcommand(aux_string, "OK", 2000);    // Kurzmitteilungsnummer senden
    
    sprintf(aux_string,"AT+CMGS=\"%s\"", SMS_number);
    answer = sendATcommand(aux_string, ">", 2000);    // send the SMS number
    if (answer == 1)
    {
  

  GPRS.print("Volk ");
  GPRS.print(Volk);
  GPRS.println(" ist abgeschwaermt");
  GPRS.print("ID ");
  GPRS.print(waagenid);
        
        GPRS.write(0x1A);
        answer = sendATcommand("", "OK", 20000);
        if (answer == 1)
        {
            Serial.print("54");
        
        }
        else
        {
            Serial.print("55");
        }
    }
    } 
    else
    {   Serial.println("56"); 
        
        Serial.println(answer, DEC);
    }
    Serial.println("57");
}
}
//**Error 60 *******************************************************************************************************************************************************************
void SMSsendenAkku() {
  
  char aux_string[30];
  startMODUL();
  delay(5000); // für Waldeinsatz und schlechten Empfang 0 standard
  Serial.println("61");
    delay(1000);
     cpin();   // PIN Simkarte setzen 
    creg();    // CREG durchführen
    if (creg_info == 0 ){ 
   
     
     
    sendATcommand("AT+CMGF=1", "OK", 1000);    // sets the SMS mode to text
    sprintf(aux_string,"AT+CSCA=\"%s\"", SMS_Kurzmitteilungsnummer); 
    answer = sendATcommand(aux_string, "OK", 2000);    // Kurzmitteilungsnummer senden
    
    sprintf(aux_string,"AT+CMGS=\"%s\"", SMS_number);
    answer = sendATcommand(aux_string, ">", 2000);    // send the SMS number
    if (answer == 1)
    {
  

  GPRS.print("Akku fast leer ");
  GPRS.print(Akku/10);
  GPRS.println(" V");
  GPRS.print("ID ");
  GPRS.print(waagenid);
        
        GPRS.write(0x1A);
        answer = sendATcommand("", "OK", 20000);
        if (answer == 1)
        {
            Serial.print("62");
        Akkusmsgesendet = 1; 
        }
        else
        {
            SMSsafe++;
            Serial.print("63");
        }
    }
    } 
    else
    {   Serial.println("64"); 
        SMSsafe++;
        Serial.println(answer, DEC);
    }
    
    Serial.println("65");
}

//*Error 65 +********************************************************************************************************************************************************************
void creg() {
    creg_info = 0;
int i = 0;    
    while( (i<20 || sendATcommand("AT+CREG?", "+CREG:0,1", 500) ||
            sendATcommand("AT+CREG?", "+CREG:0,5", 500)) == 0 ) { i++; };
  if (i >= 20){ 
    Serial.println("66");;
    creg_info = 1; 
    }            
delay(1000);
}

//*********************************************************************************************************************************************************************
void cpin() {
  char aux_string[30];
   if (PIN != "")
  {  
    sprintf(aux_string, "AT+CPIN=%s", PIN);
    answer = sendATcommand( aux_string, "OK", 2000);    // sets the PinCode
    if (answer == 1)
    {
       Serial.println("67");  
       delay(3000);
       }
    else
    {
       Serial.println("68");  
    }

  } else
 {
      Serial.println("69");  
 } }    
  






 




